import { Ratio } from './types';
/**
 * Collapses the Fraction into a single number.
 * If the denominator does not divide the numerator, the function rounds up;
 */
export declare function collapseRatio({ numerator, denominator }: Ratio): bigint;
/**
 * Multiply a ratio with a bigint.
 * @param factor a number which should be multiplied with the ratio. If given a string, it will attempt to parse it to a bigint.
 * @returns the product as a ratio.
 */
export declare function multiplyRatio({ numerator, denominator }: Ratio, factor: bigint | string): Ratio;
