/**
 * Representation of a credential registration id, which enforces that it:
 * - Is a valid Hex string
 * - Has length exactly 96, because a credId is 48 bytes.
 * - Checks the first bit is 1, which indicates that the value represents a compressed BLS12-381 curve point.
 */
export declare class CredentialRegistrationId {
    credId: string;
    constructor(credId: string);
    toJSON(): string;
}
