import { BakerId, Duration, HexString, Timestamp } from '../types';
export interface NodeInfo {
    peerVersion: string;
    localTime: Timestamp;
    peerUptime: Duration;
    networkInfo: NodeNetworkInfo;
    details: NodeInfoDetails;
}
export interface NodeNetworkInfo {
    nodeId: HexString;
    peerTotalSent: bigint;
    peerTotalReceived: bigint;
    avgBpsIn: bigint;
    avgBpsOut: bigint;
}
export declare type NodeInfoDetails = NodeInfoDetails_Bootstrapper | NodeInfoDetails_Node;
export interface NodeInfoDetails_Bootstrapper {
    tag: 'bootstrapper';
}
export interface NodeInfoDetails_Node {
    tag: 'node';
    consensusStatus: NodeInfoConsensusStatus;
}
export declare type NodeInfoConsensusStatus = NodeInfoConsensusStatusGeneric | NodeInfoConsensusStatusActive;
export interface NodeInfoConsensusStatusGeneric {
    tag: 'notRunning' | 'passive';
}
export interface NodeInfoConsensusStatusActive {
    tag: 'active';
    bakerId: BakerId;
    status: BakerConsensusInfoStatus;
}
export declare type BakerConsensusInfoStatus = BakerConsensusInfoStatusGeneric | BakerConsensusInfoStatusPassiveCommitteeInfo;
export interface BakerConsensusInfoStatusGeneric {
    tag: 'activeBakerCommitteeInfo' | 'activeFinalizerCommitteeInfo';
}
export interface BakerConsensusInfoStatusPassiveCommitteeInfo {
    tag: 'passiveCommitteeInfo';
    passiveCommitteeInfo: PassiveCommitteeInfo;
}
export declare enum PassiveCommitteeInfo {
    NotInCommittee = 0,
    AddedButNotActiveInCommittee = 1,
    AddedButWrongKeys = 2
}
