import { HexString, IpAddressString } from '..';
export interface PeerInfo {
    peerId: HexString;
    ip: IpAddressString;
    port: number;
    networkStats?: PeerNetworkStats;
    consensusInfo: PeerConsensusInfo;
}
export interface PeerNetworkStats {
    packetsSent: bigint;
    packetsReceived: bigint;
    latency: bigint;
}
export declare type PeerConsensusInfo = PeerConsensusInfoBootstrapper | PeerConsensusInfoCatchupStatus;
export interface PeerConsensusInfoBootstrapper {
    tag: 'bootstrapper';
}
export interface PeerConsensusInfoCatchupStatus {
    tag: 'nodeCatchupStatus';
    catchupStatus: NodeCatchupStatus;
}
export declare enum NodeCatchupStatus {
    UpToDate = 0,
    Pending = 1,
    CatchingUp = 2
}
