import { GenericAtomicStatement, AtomicProof } from '../commonProofTypes';
import { AttributeType } from '../web3ProofTypes';
declare type DIDString = string;
export declare type ConcordiumWeakLinkingProofV1 = {
    created: string;
    proofValue: string[];
    type: 'ConcordiumWeakLinkingProofV1';
};
export declare type AtomicProofV2 = AtomicProof<AttributeType>;
export declare type StatementProof = {
    created: string;
    proofValue: AtomicProofV2[];
    type: 'ConcordiumZKProofV3';
};
export declare type CredentialSubjectProof = {
    id: DIDString;
    proof: StatementProof;
    statement: GenericAtomicStatement<string, AttributeType>[];
};
export declare type VerifiableCredentialProof = {
    credentialSubject: CredentialSubjectProof;
    issuer: DIDString;
    type: [
        'VerifiableCredential',
        'ConcordiumVerifiableCredential',
        ...string[]
    ];
};
/**
 * Replacer to ensure dates are stringified to the timestamp attribute format.
 */
export declare function replaceDateWithTimeStampAttribute(this: any, k: string, value: any): any;
/**
 * Reviver to ensure dates are parsed from the timestamp attribute format.
 */
export declare function reviveDateFromTimeStampAttribute(this: any, _key: string, value: any): any;
export declare class VerifiablePresentation {
    presentationContext: string;
    proof: ConcordiumWeakLinkingProofV1;
    type: string;
    verifiableCredential: VerifiableCredentialProof[];
    constructor(presentationContext: string, proof: ConcordiumWeakLinkingProofV1, type: string, verifiableCredential: VerifiableCredentialProof[]);
    toString(): string;
    static fromString(json: string): VerifiablePresentation;
}
export {};
