/**
 * Representation of a transaction expiry date.
 *
 * A transaction expiry has to be in the future. Note that the concordium-node
 * will reject transactions that are too far into the future, currently the default
 * value for this rejection is 2 hours.
 */
export declare class TransactionExpiry {
    /** expiry is measured as seconds since epoch */
    expiryEpochSeconds: bigint;
    constructor(expiry: Date, allowExpired?: boolean);
    static fromEpochSeconds(seconds: bigint, allowExpired?: boolean): TransactionExpiry;
    toJSON(): number;
}
