import { AccountInfo, AccountInfoBakerV0, AccountInfoBakerV1, Authorizations, AuthorizationsV1, BlockInfo, BlockInfoV0, BlockInfoV1, ChainParameters, ChainParametersV0, ChainParametersV1, ChainParametersV2, ConsensusStatus, ConsensusStatusV0, ConsensusStatusV1, ElectionInfo, ElectionInfoV0, Keys, KeysV0, KeysV1, StakePendingChange, StakePendingChangeV0, StakePendingChangeV1 } from './types';
/** Whether {@link AccountInfo} parameter given is of type {@link AccountInfoBakerV0} */
export declare const isBakerAccountV0: (ai: AccountInfo) => ai is AccountInfoBakerV0;
/** Whether {@link AccountInfo} parameter given is of type {@link AccountInfoBakerV1} */
export declare const isBakerAccountV1: (ai: AccountInfo) => ai is AccountInfoBakerV1;
/** Whether {@link StakePendingChange} parameter given is of type {@link StakePendingChangeV0} */
export declare const isStakePendingChangeV0: (spc: StakePendingChange) => spc is StakePendingChangeV0;
/** Whether {@link StakePendingChange} parameter given is of type {@link StakePendingChangeV1} */
export declare const isStakePendingChangeV1: (spc: StakePendingChange) => spc is StakePendingChangeV1;
/** Whether {@link Authorizations} parameter given is of type {@link AuthorizationsV1} */
export declare const isAuthorizationsV1: (as: Authorizations) => as is AuthorizationsV1;
/** Whether {@link ChainParameters} parameter given is of type {@link ChainParametersV0} */
export declare const isChainParametersV0: (cp: ChainParameters) => cp is ChainParametersV0;
/** Whether {@link ChainParameters} parameter given is of type {@link ChainParametersV1} */
export declare const isChainParametersV1: (cp: ChainParameters) => cp is ChainParametersV1;
/** Whether {@link ChainParameters} parameter given is of type {@link ChainParametersV2} */
export declare const isChainParametersV2: (cp: ChainParameters) => cp is ChainParametersV2;
/** Whether {@link Keys} parameter given is of type {@link KeysV0} */
export declare const isKeysV0: (ks: Keys) => ks is KeysV0;
/** Whether {@link Keys} parameter given is of type {@link KeysV1} */
export declare const isKeysV1: (ks: Keys) => ks is KeysV1;
/** Whether {@link BlockInfo} parameter given is of type {@link BlockInfoV0} */
export declare const isBlockInfoV0: (bi: BlockInfo) => bi is BlockInfoV0;
/** Whether {@link BlockInfo} parameter given is of type {@link BlockInfoV1} */
export declare const isBlockInfoV1: (bi: BlockInfo) => bi is BlockInfoV1;
/** Whether {@link ConensusStatus} parameter given is of type {@link ConsensusStatusV0} */
export declare const isConsensusStatusV0: (cs: ConsensusStatus) => cs is ConsensusStatusV0;
/** Whether {@link ConensusStatus} parameter given is of type {@link ConsensusStatusV1} */
export declare const isConsensusStatusV1: (cs: ConsensusStatus) => cs is ConsensusStatusV1;
/** Whether {@link ElectionInfo} parameter given is of type {@link ElectionInfoV0} */
export declare const isElectionInfoV0: (ei: ElectionInfo) => ei is ElectionInfoV0;
/** Whether {@link ElectionInfo} parameter given is of type {@link ElectionInfoV1} */
export declare const isElectionInfoV1: (ei: ElectionInfo) => ei is import("./types").ElectionInfoCommon;
